package entity

import (
	"code.30cm.net/digimon/app-cloudep-product-service/pkg/domain/kyc"
	"go.mongodb.org/mongo-driver/bson/primitive"
)

type KYC struct {
	ID                 primitive.ObjectID `bson:"_id,omitempty"`
	UID                string             `bson:"uid"`                 // 驗證人 UID
	CountryRegion      string             `bson:"country_region"`      // 地區（例如 "TW", "JP", "US"...）
	Name               string             `bson:"name"`                // 真實姓名
	Identification     string             `bson:"identification"`      // 身分證字號 or 護照號碼
	IdentificationType string             `bson:"identification_type"` // ID 類型：ID_CARD, PASSPORT, RESIDENT_CERT
	Address            string             `bson:"address"`             // 戶籍地址（或居住地址）
	PostalCode         string             `bson:"postal_code"`         // 郵遞區號（海外使用）
	// 上傳文件網址（可為 object storage 的 URL）
	IDFrontImage     string     `bson:"id_front_image"`     // 身分證/護照 正面
	IDBackImage      string     `bson:"id_back_image"`      // 身分證/居留證 反面
	BankStatementImg string     `bson:"bank_statement_img"` // 銀行存摺封面照
	BankCode         string     `bson:"bank_code"`          // 銀行代碼（可為 SWIFT）
	BankName         string     `bson:"bank_name"`          // 銀行名稱（顯示用）
	BranchCode       string     `bson:"branch_code"`        // 分行代碼
	BranchName       string     `bson:"branch_name"`        // 分行名稱（顯示用）
	BankAccount      string     `bson:"bank_account"`       // 銀行帳號
	Status           kyc.Status `bson:"status"`             // 審核狀態：PENDING, APPROVED, REJECTED
	RejectReason     string     `bson:"reject_reason"`      // 若被駁回，原因描述
	UpdatedAt        int64      `bson:"updated_at,omitempty"`
	CreatedAt        int64      `bson:"created_at,omitempty"`
}

func (p *KYC) CollectionName() string {
	return "kyc"
}
